/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3DSFNODEFUNCTOR_H
#define X3DTK_X3DSFNODEFUNCTOR_H

namespace X3DTK {

class X3DAbstractNode;

class X3DSFNodeFunctor
{
public:
  virtual ~X3DSFNodeFunctor() {}
  virtual X3DAbstractNode *getNode(X3DAbstractNode const *N) = 0;
  virtual bool setNode(X3DAbstractNode *N, X3DAbstractNode *C) = 0;
  virtual bool removeNode(X3DAbstractNode *N, X3DAbstractNode *C) = 0;
  virtual void removeThisNode(X3DAbstractNode *N) = 0;
};

template<class T, class V>
class SFNodeFunctor : public X3DSFNodeFunctor
{
public:
  SFNodeFunctor(V *T:: *node);
  
  X3DAbstractNode *getNode(X3DAbstractNode const *N);
  bool setNode(X3DAbstractNode *N, X3DAbstractNode *C);
  bool removeNode(X3DAbstractNode *N, X3DAbstractNode *C);
  void removeThisNode(X3DAbstractNode *N);
  
private:
  V *T::*_node;
};

}

#include "X3DSFNodeFunctor.inl"

#endif
